package com.wyattjmiller.dicerollerapp

import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import android.view.View
import android.widget.Button
import android.widget.TextView

class DiceActivity : AppCompatActivity() {

    // Private member variables per the layout
    private lateinit var mDiceTextView: TextView
    private lateinit var mRollButton: Button

    // Private member variable - other
    private lateinit var mDieStatus: Die

    // The following methods are for keeping track of the Android lifecycle using Logcat
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_dice)

        mDiceTextView = findViewById(R.id.diceTextView)
        mRollButton = findViewById(R.id.rollButton)

        // I realize that you toggle visability in xml
        mDiceTextView.visibility = View.INVISIBLE
    }

    override fun onStart() {
        Log.d("LIFECYCLE", "onStart invoked!")
        super.onStart()
    }

    override fun onResume() {
        Log.d("LIFECYCLE", "onResume invoked!")
        super.onResume()
    }

    override fun onPause() {
        Log.d("LIFECYCLE", "onPause invoked!")
        super.onPause()
    }

    override fun onStop() {
        Log.d("LIFECYCLE", "onStop invoked!")
        super.onStop()
    }

    override fun onDestroy() {
        Log.d("LIFECYCLE", "onDestroy invoked!")
        super.onDestroy()
    }

    // code behind for the 'roll' button
    fun onClickDieRoll(view: View?) {
        when (Randomizer().randomDieRoll()) {
            0 -> {
                mDieStatus = Die.One
                mDiceTextView.text = mDieStatus.toString()
            }
            1 -> {
                mDieStatus = Die.Two
                mDiceTextView.text = mDieStatus.toString()
            }
            2 -> {
                mDieStatus = Die.Three
                mDiceTextView.text = mDieStatus.toString()
            }
            3 -> {
                mDieStatus = Die.Four
                mDiceTextView.text = mDieStatus.toString()
            }
            4 -> {
                mDieStatus = Die.Five
                mDiceTextView.text = mDieStatus.toString()
            }
            5 -> {
                mDieStatus = Die.Six
                mDiceTextView.text = mDieStatus.toString()
            }
        }

        if (mDiceTextView.visibility == View.INVISIBLE) {
            mDiceTextView.visibility = View.VISIBLE
        }
    }
}